# Script to create corrected netCDF file for rlut for CESM model output. 
#
# Rick Russotto
# Started 11-7-16

# This needs to be done for 3 experiments: piControl, G1, abrupt4xCO2. 

# The calculation is FSNTOA - FSNT + FLNT. 

# Don't really bother with functions because I only need to do this once...

# Better to try to do this with NCO commands or to do it within Python? 

import os 
import netCDF4 as nc4
import numpy as np

#Copy the relevant native CESM files into the directory where corrected output will go
os.chdir('../nobackup/CESM_native')
os.system('cp *FSNTOA.* ../CESM_corrected/')
os.system('cp *FSNT.* ../CESM_corrected/')
os.system('cp *FLNT.* ../CESM_corrected/')
os.chdir('../CESM_corrected')

#After doing some research, nco commands seem like the best option. 

#Append the different variables into one file 
#(First add FSNTOA data to the FSNT file; then add both to the FLNT file)
#(Separately for each run)

#piControl
os.system('ncks -A b.e103.B1850CAM5CN.f19_g16.e01.frk.001.cam2.h0.FSNTOA.000101-005012.nc b.e103.B1850CAM5CN.f19_g16.e01.frk.001.cam2.h0.FSNT.000101-005012.nc')
os.system('ncks -A b.e103.B1850CAM5CN.f19_g16.e01.frk.001.cam2.h0.FSNT.000101-005012.nc b.e103.B1850CAM5CN.f19_g16.e01.frk.001.cam2.h0.FLNT.000101-005012.nc')

#G1
os.system('ncks -A b.e103.B1850CAM5CN.f19_g16.G1.hp.001.cam2.h0.FSNTOA.000101-006012.nc b.e103.B1850CAM5CN.f19_g16.G1.hp.001.cam2.h0.FSNT.000101-006012.nc')
os.system('ncks -A b.e103.B1850CAM5CN.f19_g16.G1.hp.001.cam2.h0.FSNT.000101-006012.nc b.e103.B1850CAM5CN.f19_g16.G1.hp.001.cam2.h0.FLNT.000101-006012.nc')

#abrupt4xCO2
os.system('ncks -A b.e103.B1850CAM5CN.f19_g16.cmip5.frk.001.trl.cam2.h0.FSNTOA.000101-015012.nc b.e103.B1850CAM5CN.f19_g16.cmip5.frk.001.trl.cam2.h0.FSNT.000101-015012.nc')
os.system('ncks -A b.e103.B1850CAM5CN.f19_g16.cmip5.frk.001.trl.cam2.h0.FSNT.000101-015012.nc b.e103.B1850CAM5CN.f19_g16.cmip5.frk.001.trl.cam2.h0.FLNT.000101-015012.nc')

#Combine the variables within the files
os.system('ncap -s "rlut=FSNTOA-FSNT+FLNT" -v b.e103.B1850CAM5CN.f19_g16.e01.frk.001.cam2.h0.FLNT.000101-005012.nc rlut_Amon_CESM1-CAM5.1-FV2_piControl_r1i1p1_000101-005012.nc')
os.system('ncap -s "rlut=FSNTOA-FSNT+FLNT" -v b.e103.B1850CAM5CN.f19_g16.G1.hp.001.cam2.h0.FLNT.000101-006012.nc rlut_Amon_CESM1-CAM5.1-FV2_G1_r1i1p1_000101-006012.nc')
os.system('ncap -s "rlut=FSNTOA-FSNT+FLNT" -v b.e103.B1850CAM5CN.f19_g16.cmip5.frk.001.trl.cam2.h0.FLNT.000101-015012.nc rlut_Amon_CESM1-CAM5.1-FV2_abrupt4xCO2_000101-015012.nc')

#Remove the individual variable files that were copied here
os.system('rm b.e103*')

